# Tools

Pour utiliser toutes ces fonctions, il y a une collection d'utilitaires
spécialisés. Leur interface en `CLI` est assez rudimentaire, mais la
plupart savent donner quelques indices avec la commande `list`. Exemple:

```
tth@konrad:~/Devel/libtthimage$ tga_filtres list
*** tga_filtres v 0.0.17 [0.59] (dwtfywl) TontonTh 2018

Usage:
        tga_filtres <src.tga> FILTR <dst.tga> [p1] ... [pn]
-+- This is the `tthimage' library v0.4.50 (dwtfywl 2022) tTh
  commande  | type arg |  explication
------------+----------+------------------------------------
 liss2x2    |          |  lissage 2x2
 hipass     |          |
 lopass     |          |
 prewitt    | i        |  rotation [0..8]
 random     | ii       |  try it...
```
La colonne du milieu indique le type des paramètres :

- `i` pour un nombre entier
- `d` pour un flottant en double précision
- `s` pour une chaine, ex: un nom de fichier
- `f` pour un flag : 0, F, 1, T

## tga_alpha

Manipulation du canal alpha (la transparence), lequel canal
est globalement mal géré par l'ensemble de libtthimage.

## tga_applymap

La gestion de la ligne de commande est désastreuse. **À REFAIRE**

## tga_cadre

Pas mal de façons de mettre un cadre sur l'image.
Niveau de kitchitude assez élevé.
Paramètres mal documentés.

## tga_combine

## tga_dither

Comment drastiquement réduire le nombre de couleurs d'une image ?

## tga_export

Attendu avec impatience, il aura le support complet des PNG. Un jour...

## tga_effects

## tga_equalize

## tga_filtres

## tga_incrust

## tga_makehf15

## tga_mires

La génération de diverses image de test ou de calibration.

## tga_pattern

## tga_remap

## tga_television

## tga_tools

Celui ci est très utile pour la recherche de problèmes ou l'automatisation
de certaines tâches. Exemple :

```
tth@konrad:~/Devel/libtthimage$ tga_tools getdimweb mire.tga 
width=512 height=512
tth@konrad:~/Devel/libtthimage$ 
```

## genplot2

Outil de tracé pseudo-générique et farci de bugs. WIP ME HARDLY !
